## dpdk 21.11.4

=== examples/multi_process/simple_mp/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2010-2014 Intel Corporation

# binary name
APP = simple_mp

# all source are stored in SRCS-y
SRCS-y := main.c mp_commands.c

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -DALLOW_EXPERIMENTAL_API

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared
	test -d build && rmdir -p build || true

=== debian/changelog ===
dpdk (21.11.4-0ubuntu0.22.04.1~cloud0) focal-yoga; urgency=medium

  * New upstream release for the Ubuntu Cloud Archive.

 -- Openstack Ubuntu Testing Bot <openstack-testing-bot@ubuntu.com>  Wed, 23 Aug 2023 04:50:00 +0000

dpdk (21.11.4-0ubuntu0.22.04.1) jammy; urgency=medium

  * Merge LTS stable release 21.11.4 (LP: #2026351)
    - Full release notes are available at:
      https://doc.dpdk.org/guides-21.11/rel_notes/release_21_11.html#id9
  * Added missing symbols:
    - d/librte-common-sfc-efx22.symbols: INTERNAL
    - d/librte-vhost22.symbols: EXPERIMENTAL
  * Included changes from Debian unstable in 22.11.2-1:
    [Christian Ehrhardt]
    - d/t/test-fastsuite: test env before breaking tests for known issues

 -- Miriam España Acebal <miriam.espana@canonical.com>  Thu, 06 Jul 2023 13:12:57 +0200

dpdk (21.11.3-0ubuntu0.22.04.1) jammy; urgency=medium

  * Merge LTS stable release 21.11.3 (LP: #2002404)
    fixing various issues from descriptions to hard crashes
    - Full release notes are available at:
      https://doc.dpdk.org/guides-21.11/rel_notes/release_21_11.html#id5

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Tue, 17 Jan 2023 11:31:40 +0100

dpdk (21.11.2-0ubuntu0.22.04.1) jammy-security; urgency=medium

  * Merge LTS stable release 21.11.2
    - Among many general fixed this adresses a CVE:
      DoS triggered by sending a crafted Vhost header (CVE-2022-2132)
    - Full release notes are available at:
      https://doc.dpdk.org/guides-21.11/rel_notes/release_21_11.html#id1

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 08 Sep 2022 10:18:45 +0200

## dpdk 21.11.6

=== debian/changelog ===
dpdk (21.11.6-0ubuntu0.22.04.2) jammy-security; urgency=medium

  * SECURITY UPDATE: DoS via OOB read in checksum offload feature
    - debian/patches/CVE-2024-11614.patch: fix Rx checksum calculation in
      lib/vhost/virtio_net.c.
    - CVE-2024-11614

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 18 Dec 2024 13:32:23 -0500

dpdk (21.11.6-0ubuntu0.22.04.1) jammy; urgency=medium

  * Merge LTS stable release 21.11.6 (LP: #2040463)
    - Full release notes are available at:
      https://doc.dpdk.org/guides-21.11/rel_notes/release_21_11.html#id17
  * d/dpdk-dev.lintian-overrides: a pair of admin tools without manpages.
  * Add new symbols:
    - d/librte-eventdev22.symbols due to https://github.com/DPDK/dpdk-stable/commit/5a037544
    - d/librte-common-sfc-efx22.symbols due to https://github.com/DPDK/dpdk-stable/commit/cf1e1a8e
  * d/p/disable_autopkgtest_fails.patch: Refresh.

 -- Miriam España Acebal <miriam.espana@canonical.com>  Mon, 29 Jan 2024 13:52:29 +0100

## dpdk 21.11.7

=== debian/changelog ===
dpdk (21.11.7-0ubuntu0.22.04.1) jammy; urgency=medium

  * Merge LTS stable release 21.11.7 (LP: #2067480)
    - Full release notes are available at:
      https://doc.dpdk.org/guides-21.11/rel_notes/release_21_11.html#id22

 -- Miriam España Acebal <miriam.espana@canonical.com>  Wed, 04 Sep 2024 12:51:05 +0200

## dpdk 21.11.9

=== meson_options.txt ===
# Please keep these options sorted alphabetically.

option('check_includes', type: 'boolean', value: false, description:
       'build "chkincs" to verify each header file can compile alone')
option('cpu_instruction_set', type: 'string', value: 'auto',
	description: 'Set the target machine ISA (instruction set architecture). Will be set according to the platform option by default.')
option('developer_mode', type: 'feature', description:
       'turn on additional build checks relevant for DPDK developers')
option('disable_drivers', type: 'string', value: '', description:
       'Comma-separated list of drivers to explicitly disable.')
option('disable_libs', type: 'string', value: '', description:
       'Comma-separated list of libraries to explicitly disable. [NOTE: not all libs can be disabled]')
option('drivers_install_subdir', type: 'string', value: 'dpdk/pmds-<VERSION>', description:
       'Subdirectory of libdir where to install PMDs. Defaults to using a versioned subdirectory.')
option('enable_docs', type: 'boolean', value: false, description:
       'build documentation')
option('enable_drivers', type: 'string', value: '', description:
       'Comma-separated list of drivers to build. If unspecified, build all drivers.')
option('enable_driver_sdk', type: 'boolean', value: false, description:
       'Install headers to build drivers.')
option('enable_kmods', type: 'boolean', value: false, description:
       'build kernel modules')
option('examples', type: 'string', value: '', description:
       'Comma-separated list of examples to build by default')
option('flexran_sdk', type: 'string', value: '', description:
       'Path to FlexRAN SDK optional Libraries for BBDEV device')
option('ibverbs_link', type: 'combo', choices : ['static', 'shared', 'dlopen'], value: 'shared', description:
       'Linkage method (static/shared/dlopen) for Mellanox PMDs with ibverbs dependencies.')
option('include_subdir_arch', type: 'string', value: '', description:
       'subdirectory where to install arch-dependent headers')
option('kernel_dir', type: 'string', value: '', description:
       'Path to the kernel for building kernel modules. Headers must be in $kernel_dir or $kernel_dir/build. Modules will be installed in /lib/modules.')
option('machine', type: 'string', value: 'auto', description:
       'Alias of cpu_instruction_set.')
option('max_ethports', type: 'integer', value: 32, description:
       'maximum number of Ethernet devices')
option('max_lcores', type: 'string', value: 'default', description:
       'Set maximum number of cores/threads supported by EAL; "default" is different per-arch, "detect" detects the number of cores on the build machine.')
option('max_numa_nodes', type: 'string', value: 'default', description:
       'Set the highest NUMA node supported by EAL; "default" is different per-arch, "detect" detects the highest NUMA node on the build machine.')
option('mbuf_refcnt_atomic', type: 'boolean', value: true, description:
       'Atomically access the mbuf refcnt.')
option('platform', type: 'string', value: 'native', description:
       'Platform to build, either "native", "generic" or a SoC. Please refer to the Linux build guide for more information.')
option('enable_trace_fp', type: 'boolean', value: false, description:
       'enable fast path trace points.')
option('tests', type: 'boolean', value: true, description:
       'build unit tests')
option('use_hpet', type: 'boolean', value: false, description:
       'use HPET timer in EAL')

=== examples/helloworld/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2010-2014 Intel Corporation

# binary name
APP = helloworld

# all source are stored in SRCS-y
SRCS-y := main.c

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -DALLOW_EXPERIMENTAL_API

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared
	test -d build && rmdir -p build || true

=== examples/ipsec-secgw/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2016 Intel Corporation

APP = ipsec-secgw

#
# all source are stored in SRCS-y
#
SRCS-y += parser.c
SRCS-y += ipsec.c
SRCS-y += esp.c
SRCS-y += sp4.c
SRCS-y += sp6.c
SRCS-y += sa.c
SRCS-y += sad.c
SRCS-y += rt.c
SRCS-y += ipsec_process.c
SRCS-y += ipsec-secgw.c
SRCS-y += ipsec_worker.c
SRCS-y += event_helper.c
SRCS-y += flow.c

CFLAGS += -gdwarf-2

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -DALLOW_EXPERIMENTAL_API
CFLAGS += -Wno-address-of-packed-member

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared
	test -d build && rmdir -p build || true

=== examples/kni/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2010-2014 Intel Corporation

# binary name
APP = kni

# all source are stored in SRCS-y
SRCS-y := main.c

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
CFLAGS += -DALLOW_EXPERIMENTAL_API
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

LDFLAGS += -pthread

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared
	test -d build && rmdir -p build || true

=== examples/l3fwd/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2010-2016 Intel Corporation

# binary name
APP = l3fwd

# all source are stored in SRCS-y
SRCS-y := main.c l3fwd_lpm.c l3fwd_fib.c l3fwd_em.c l3fwd_event.c
SRCS-y += l3fwd_event_generic.c l3fwd_event_internal_port.c

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
# Added for 'rte_eth_link_to_str()'
CFLAGS += -DALLOW_EXPERIMENTAL_API
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared
	test -d build && rmdir -p build || true

=== examples/vhost/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2010-2014 Intel Corporation

# binary name
APP = vhost-switch

# all source are stored in SRCS-y
SRCS-y := main.c virtio_net.c ioat.c

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

LDFLAGS += -pthread

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -DALLOW_EXPERIMENTAL_API

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared
	test -d build && rmdir -p build || true

=== debian/changelog ===
dpdk (21.11.9-0ubuntu0.22.04.2) jammy-security; urgency=medium

  * SECURITY UPDATE: DoS and info disclosure in mlx5
    - debian/patches/CVE-2025-23259.patch: fix out-of-order completions in
      ordinary Rx burst in drivers/net/mlx5/linux/mlx5_verbs.c,
      drivers/net/mlx5/mlx5_devx.c, drivers/net/mlx5/mlx5_ethdev.c,
      drivers/net/mlx5/mlx5_rx.c, drivers/net/mlx5/mlx5_rx.h,
      drivers/net/mlx5/mlx5_rxq.c.
    - CVE-2025-23259

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 07 Oct 2025 11:08:52 -0400

dpdk (21.11.9-0ubuntu0.22.04.1) jammy; urgency=medium

  * Merge LTS stable release 21.11.9 (LP: #2067480)
    - Full release notes are available at:
      https://doc.dpdk.org/guides-21.11/rel_notes/release_21_11.html#id32

 -- Arif Ali <arif.ali@canonical.com>  Tue, 06 May 2025 06:56:35 +0000

=== debian/control ===
Source: dpdk
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian DPDK Maintainers <pkg-dpdk-devel@lists.alioth.debian.org>
Uploaders: Luca Boccassi <bluca@debian.org>,
           Christian Ehrhardt <christian.ehrhardt@canonical.com>,
           Santiago Ruano Rincón <santiagorr@riseup.net>,
Build-Depends: chrpath,
               debhelper-compat (= 12),
               dh-python,
               doxygen <!nodoc>,
               graphviz <!nodoc>,
               inkscape <!nodoc>,
               libbpf-dev,
               libbsd-dev,
               libelf-dev,
               libfdt-dev,
               libibverbs-dev (>= 23~),
               libipsec-mb-dev [amd64],
               libisal-dev [amd64],
               libjansson-dev,
               libmnl-dev,
               libnuma-dev,
               libpcap-dev,
               libssl-dev,
               meson (>= 0.47.1~),
               pkg-config,
               python3,
               python3-pyelftools,
               python3-sphinx <!nodoc>,
               python3-sphinx-rtd-theme <!nodoc>,
               texlive-fonts-recommended <!nodoc>,
               texlive-latex-extra <!nodoc>,
               zlib1g-dev,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Section: libs
Homepage: https://www.dpdk.org
Vcs-Git: https://salsa.debian.org/debian/dpdk.git -b unstable
Vcs-Browser: https://salsa.debian.org/debian/dpdk

Package: dpdk
Section: admin
Architecture: amd64 arm64 i386 ppc64el
Depends: lsb-base (>= 3.2-14),
         pci.ids | hwdata,
         pciutils,
         ${misc:Depends},
         ${python3:Depends},
# Recommend a subset of more tested, more used and more supported libs
Recommends: librte-mempool22,
            librte-mempool-ring22,
            librte-net-af-packet22,
            librte-net-bond22,
            librte-net-e1000-22,
            librte-net-fm10k22,
            librte-net-i40e22,
            librte-net-ixgbe22,
            librte-net-kni22,
            librte-net-mlx4-22,
            librte-net-mlx5-22,
            librte-net-netvsc22,
            librte-net-pcap22,
            librte-net-tap22,
            librte-net-thunderx22,
            librte-net-vdev-netvsc22,
            librte-net-vhost22,
            librte-net-virtio22,
            librte-net-vmxnet3-22,
            python3-pyelftools,
Suggests: dpdk-doc,
          dpdk-kmods-dkms,
          librte-meta-baseband,
          librte-meta-bus,
          librte-meta-compress,
          librte-meta-crypto,
          librte-meta-dma,
          librte-meta-event,
          librte-meta-mempool,
          librte-meta-net,
          librte-meta-raw,
          librte-meta-allpmds,
Breaks: dpdk-dev (<< 18.11-4~),
Replaces: dpdk-dev (<< 18.11),
Description: Data Plane Development Kit (runtime)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime environment to run DPDK applications.

Package: librte-meta-baseband
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Depends: ${librte:Baseband},
         ${misc:Depends},
Description: Data Plane Development Kit (baseband libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte baseband libraries.

Package: librte-meta-bus
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Depends: ${librte:Bus},
         ${misc:Depends},
Description: Data Plane Development Kit (bus libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte bus libraries.

Package: librte-meta-compress
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Depends: ${librte:Compress},
         ${misc:Depends},
Description: Data Plane Development Kit (compress libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte compress libraries.

Package: librte-meta-crypto
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Depends: ${librte:Crypto},
         ${misc:Depends},
Description: Data Plane Development Kit (crypto libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte crypto libraries.

Package: librte-meta-dma
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Depends: ${librte:Dma},
         ${misc:Depends},
Description: Data Plane Development Kit (dma libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte dma libraries.

Package: librte-meta-event
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Depends: ${librte:Event},
         ${misc:Depends},
Description: Data Plane Development Kit (event libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte event libraries.

Package: librte-meta-mempool
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Depends: ${librte:Mempool},
         ${misc:Depends},
Description: Data Plane Development Kit (mempool libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte mempool libraries.

Package: librte-meta-net
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Depends: ${librte:Net},
         ${misc:Depends},
Description: Data Plane Development Kit (net libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte net libraries.

Package: librte-meta-raw
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Depends: ${librte:Raw},
         ${misc:Depends},
Description: Data Plane Development Kit (raw libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte raw libraries.

Package: librte-meta-allpmds
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Depends: ${librte:Allpmds},
         ${misc:Depends},
Description: Data Plane Development Kit (all poll mode drivers)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all poll mode drivers produced by DPDK.

Package: librte-meta-all
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Depends: ${librte:All},
         ${misc:Depends},
Description: Data Plane Development Kit (all sub-libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all librte libraries produced by DPDK.

Package: dpdk-dev
Section: oldlibs
Architecture: amd64 arm64 i386 ppc64el
Breaks: dpdk (<< 18.11-4~),
Replaces: dpdk (<< 18.11-4),
Depends: libdpdk-dev (>= ${source:Version}),
         python3,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Data Plane Development Kit (dev tools)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains tools useful to a developer and for dpdk self tests.

Package: dpdk-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Homepage: https://dpdk.org/doc/guides/index.html
Depends: fonts-font-awesome,
         fonts-lato,
         fonts-roboto-slab,
         libjs-jquery,
         libjs-underscore,
         python3:any,
         ${misc:Depends},
         ${python3:Depends},
Recommends: ${python3:Recommends},
Description: Data Plane Development Kit (documentation)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the complete set of documentation and guides.

Package: libdpdk-dev
Section: libdevel
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: libbpf-dev,
         libbsd-dev,
         libibverbs-dev,
         libipsec-mb-dev [amd64],
         libisal-dev [amd64],
         libelf-dev,
         libfdt-dev,
         libjansson-dev,
         libmnl-dev,
         libnuma-dev,
         libpcap-dev,
         libssl-dev,
         zlib1g-dev,
         ${librte:All},
         ${misc:Depends},
Description: Data Plane Development Kit (basic development files)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the basic headers and library files required to
 build external applications which will also require at least SSE3 support
 when running.
 .
 libdpdk.pc: note that CFLAGS might contain an -march flag higher than typical
 baseline.
 This is required for a number of static inline functions in the public headers.

Package: librte-acl22
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: https://dpdk.org/doc/api/rte__acl_8h.html
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Conflicts: libdpdk0,
Description: Data Plane Development Kit (librte-acl runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte-acl.

Package: librte-baseband-acc100-22
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: https://doc.dpdk.org/guides/bbdevs/acc100.html
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Conflicts: libdpdk0,
Description: Data Plane Development Kit (librte-baseband-acc100 runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte-baseband-acc100.

Package: librte-baseband-fpga-5gnr-fec22
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: https://doc.dpdk.org/guides/bbdevs/fpga_5gnr_fec.html
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Conflicts: libdpdk0,
Description: Data Plane Development Kit (librte-baseband-fpga-5gnr-fec runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte-baseband-fpga-5gnr-fec.

Package: librte-baseband-fpga-lte-fec22
Architecture: amd64 arm64 i386 ppc64el
Multi-Arch: same
Homepage: https://doc.dpdk.org/guides/bbdevs/fpga_lte_fec.html
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Conflicts: libdpdk0,
Description: Data Plane Development Kit (librte-baseband-fpga-lte-fec runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run

=== debian/rules ===
#!/usr/bin/make -f

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/default.mk

# Upstream now defines a single ABI across all libs that we will use
DPDK_ABI := $(shell cat ABI_VERSION | cut -d. -f1)
# Experimental libs will have 0.200 on actual ABI 20.0
DPDK_EXP_ABI := "0.$(shell cat ABI_VERSION | cut -d. -f1-2 | tr -d ".")"

ifeq (,$(findstring terse,$(DEB_BUILD_OPTIONS)))
	export DH_VERBOSE=1
	export DH_OPTIONS=-v
endif

# People rebuilding this package can overwrite RTE_PLATFORM
# via DEB_BUILD_OPTIONS if they like
ifneq (,$(filter rte_machine=%,$(DEB_BUILD_OPTIONS)))
	echo "WARNING: the machine setting is deprecated, please use platform (rte_platform)"
    RTE_PLATFORM ?= $(patsubst rte_machine=%,%,$(filter rte_platform=%,$(DEB_BUILD_OPTIONS)))
endif
ifneq (,$(filter rte_platform=%,$(DEB_BUILD_OPTIONS)))
    RTE_PLATFORM ?= $(patsubst rte_platform=%,%,$(filter rte_platform=%,$(DEB_BUILD_OPTIONS)))
endif
# default to minimal base, without setting this it would build
# -march=native which is a non portable invariant
RTE_PLATFORM ?= "generic"

ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
BUILD_DOCS=n
else
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
BUILD_DOCS=n
# to stop dh_installdoc from running
export DEB_BUILD_PROFILES += nodoc
else
BUILD_DOCS=y
endif
endif

# Allow to pass specific configure flags to meson as a comma separated list
ifneq (,$(filter dpdk_config_options=%,$(DEB_BUILD_OPTIONS)))
# GNU Makefile hack: can't directly escape comma and spaces, so use variables
    comma := ,
    empty :=
    space := $(empty) $(empty)
    DPDK_CONFIG_OPTIONS ?= $(subst $(comma),$(space),$(patsubst dpdk_config_options=%,%,$(filter dpdk_config_options=%,$(DEB_BUILD_OPTIONS))))
endif

%:
	dh $@ --with python3 --buildsystem=meson

override_dh_gencontrol:
	dh_gencontrol
	# debian/files will not exist until dh_gencontrol has ran at least once,
	# so we need to run gencontrol for libdpdk-dev after.
	# The list of libraries and PMDs is everchanging, so generate the dependency
	# list for libdpdk-dev to avoid having to maintain it manually.
	# Various meta packages help users to gain a granular access per lib-subtype.
	# The recommends list for dpdk has more common libs, all full meta categories
	# are listed as suggests.
	dh_gencontrol -p libdpdk-dev          -- -V"librte:All=`grep      -E 'librte-*'           ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-all      -- -V"librte:All=`grep      -E 'librte-*'           ./debian/files | grep -v dbgsym | grep -v 'librte-meta-' | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-baseband -- -V"librte:Baseband=`grep -E 'librte-baseband-.*' ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-bus      -- -V"librte:Bus=`grep      -E 'librte-bus-.*'      ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-compress -- -V"librte:Compress=`grep -E 'librte-compress-.*' ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-crypto   -- -V"librte:Crypto=`grep   -E 'librte-crypto-.*'   ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-dma      -- -V"librte:Dma=`grep      -E 'librte-dma-.*'      ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-event    -- -V"librte:Event=`grep    -E 'librte-event-.*'    ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-mempool  -- -V"librte:Mempool=`grep  -E 'librte-mempool-.*'  ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-net      -- -V"librte:Net=`grep      -E 'librte-net-.*'      ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-raw      -- -V"librte:Raw=`grep      -E 'librte-raw-.*'      ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-allpmds -- -V"librte:Allpmds=`for pmd in $$(find -type d -wholename './debian/librte-*dpdk/pmds-*'); do awk -v "ver=$(DEB_VERSION)" '/^Package:/ {printf("%s (= %s), \n",$$2,ver)}' "$${pmd}/../../../../../DEBIAN/control"; done | LC_ALL=C sort --stable | xargs`"

override_dh_auto_clean:
	rm -f doc/guides/compressdevs/overview_feature_table.txt \
		doc/guides/cryptodevs/overview_aead_table.txt \
		doc/guides/cryptodevs/overview_asym_table.txt \
		doc/guides/cryptodevs/overview_auth_table.txt \
		doc/guides/cryptodevs/overview_cipher_table.txt \
		doc/guides/cryptodevs/overview_feature_table.txt \
		doc/guides/nics/overview_table.txt
	# test directory for sockets, etc
	rm -rf $(CURDIR)/tmpdir
	# every PMD package has a ldconfig-escape lintian warning, so we generate an override, delete them on cleanup
	find debian -type f \( -iname "librte-*.lintian-overrides" ! -iname "librte-meta*.lintian-overrides" \) -delete
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure -- $(DPDK_CONFIG_OPTIONS) \
		--includedir=include/dpdk \
		--default-library=shared \
		-Dinclude_subdir_arch=../$(DEB_HOST_MULTIARCH)/dpdk \
		-Dplatform=$(RTE_PLATFORM)
	head obj-$(DEB_HOST_GNU_TYPE)/compile_commands.json || find . -name compile_commands.json
	grep -q -e '-mcpu=power8' -e '-march=corei7' -e '-march=armv8-a+crc' \
		obj-$(DEB_HOST_GNU_TYPE)/compile_commands.json \
		|| (echo "Error: unexpected target cpu"; exit 1)

override_dh_auto_build-indep:
ifeq (y,$(BUILD_DOCS))
	dh_auto_build -- doc
	# NINJA DOC INSTALL DOES NOT WORK - .buildinfo present, css missing
	rm -rf obj-$(DEB_HOST_MULTIARCH)/doc/guides/guides/.buildinfo obj-$(DEB_HOST_MULTIARCH)/doc/guides/html/.doctrees
endif

# ninja install doc does not work, will rebuild everything,
# only dpdk-doc as arch: all so just skip it
override_dh_auto_install-indep:

override_dh_auto_install-arch:
	dh_auto_install
	# Package(s): libdpdk-<NAME><VER> (bare runtime libs and PMDs)
	# if lib names end in a number, insert a "-"
	# if libraries are fully experimental set zero as package name suffix, otherwise DPDK_ABI
	# every PMD package has a ldconfig-escape lintian warning, so we generate an override
	for lib in $$(ls -1 debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.so.*); do \
	  LN=$$(basename $${lib} | sed -e 's/\.so\.[0-9\.]*$$//' | tr '_' '-'); \
	  if echo $${LN} | grep -q ".*[0-9]$$"; then \
	    PKG="$${LN}-"; \
	  else \
	    PKG="$${LN}"; \
	  fi; \
	  if echo $${lib} | grep -q "\.so\.0\.[0-9]*$$"; then \
	    PKG="$${PKG}$(DPDK_EXP_ABI)"; \
	  else \
	    PKG="$${PKG}$(DPDK_ABI)"; \
	  fi; \
	  LIBF="$$(basename $${lib})"; \
	  dh_install -p $${PKG} usr/lib/$(DEB_HOST_MULTIARCH)/$${LIBF}; \
	  if [ -f debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*/*/$${LIBF} ]; then \
	    dh_install -p $${PKG} usr/lib/$(DEB_HOST_MULTIARCH)/*/*/$${LIBF}; \
	    echo "ldconfig-escape" > $(CURDIR)/debian/$${PKG}.lintian-overrides; \
	  fi; \
	done
	# Strip RPATH, hard-coded in test/test/meson.build at the moment

=== debian/tests/control ===
Tests: test-initscripts
Restrictions: allow-stderr, isolation-machine, needs-root, skippable
Depends: dpdk, gawk, mount, systemd, sysvinit-utils, iproute2
Architecture: amd64 arm64 armhf i386 ppc64el

Tests: test-linkage
Restrictions: allow-stderr, skippable
Depends: libdpdk-dev, libc6-dev, gcc, grep, libpcap-dev, pax-utils, pkg-config
Architecture: amd64 arm64 armhf i386 ppc64el

Tests: test-autotest
Restrictions: allow-stderr, isolation-machine, needs-root, skippable
Depends: dpdk-dev [amd64 arm64 i386 ppc64el], python3, python3-pexpect

Tests: test-fastsuite
Restrictions: allow-stderr, skippable
Depends: build-essential, @builddeps@
Architecture: amd64 arm64 armhf i386 ppc64el

=== debian/watch ===
version=4
https://fast.dpdk.org/rel/dpdk-(.*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
